/*
 * main.c
 *
 * Created: 11/6/2023 5:00:42 PM
 *  Author: controllerstech
 */ 

#define F_CPU 5000000
#include <xc.h>
#include <util/delay.h>
#include <avr/interrupt.h>

void clkInit(void)
{
	_PROTECTED_WRITE(CLKCTRL.MCLKCTRLA, 0);  // Internal 20MHz OSC, CLKOUT=0
	_PROTECTED_WRITE(CLKCTRL.MCLKCTRLB, 0x03);  // PEN=1, DIV=4
	while ((CLKCTRL.MCLKSTATUS & (1<<4)) == 0);  // wait for the osc to stabilize.
}

void uartInit ()
{
	USART0.CTRLB = (1<<7)|(1<<6);  // Enable RX and TX
	USART0.CTRLC = 0x03;  // Asynch mode, no parity, 1 stop bit, 8 data bits
	USART0.BAUD = 174;  // PER_CLK = 5MHz, Baud = 115200
	USART0.STATUS |= 1<<6;  // Clear TXCIF flag
	
	PORTB.DIR = 0x04;  // PB2->OUT, PB3->IN
}

void uartSendByte (char byte)
{
	USART0.TXDATAL = byte;
	while (((USART0.STATUS)&(1<<6)) == 0);  // wait for the TXCIF bit to set
	USART0.STATUS |= (1<<6);  // clear the TXCIF flag
}

void uartSendStr (char *str)
{
	while (*str)
	{
		uartSendByte(*str++);
	}
}

char datatosend[] = "Hello World from AVR\r\n";
int main(void)
{
	clkInit();
	uartInit();
    while(1)
    {
         uartSendStr(datatosend);
		 _delay_ms(1000);
    }
}